//Leons Petrazickis
//7of9 Events Generator
//Uses St Leo's Civ++ Event Engine V1.0

#include<fstream.h>
#include<string.h>	//Delete this

ofstream fout("events.txt");		//creates a variable of type ofstream

//Triggers
void citytaken(char city[255],
			   char attacker[255],
			   char defender[255]);
void negotiation(char talker[255],
				 char talkertype[255],
				 char listener[255],
				 char listenertype[255]);
void randomturn(int denominator);
void scenarioloaded();
void turn(int turn);
void unitkilled(char unit[255],
				char attacker[255],
				char defender[255]);

//Actions
void createunit(char owner[255],
				char unit[255],
				char veteran[255],
				char homecity[255],
				char loc[255]);
void justonce();
void noschism(char defender[255]);
void playwavefile(char filename[255]);
void text(char text[32000]);

//Keywords
void beginevents();
void endevents();
void IF();
void THEN();
void ENDIF();
void debug();

//Useful Variable
char civs[8][256] = {
		"Venetians",
		"Hafsids",
		"Teutonics",
		"English",
		"Spaniards",
		"French",
		"Independents",
		"Barbarians"};

void main(){
	//Scenario-specific variables
	char answer = ' ';			//Answer to prompts
	int x=0;					//Index for loops
	int number = 5;
	int engfreq = 3;
	int galfreq = 4;
	int generalinterval = 15;
	char assloc[] = "70,106";

	cout << "Welcome to the Setup Program for Imperial Ambition:\n";
	cout << "\t-Answer in lowercase and follow up with an [Enter]\n";
	cout << "\t-Run it again whenever needed\n";
	cout << "\t-If it summons aliens from Alpha Centauri, it is not my fault\n\n";

	beginevents();
	//debug();

	IF();
	noschism("ANYBODY");
	THEN();
	ENDIF();

	IF();
	negotiation("Independents","HUMANORCOMPUTER","ANYBODY","HUMANORCOMPUTER");
	THEN();
	ENDIF();

	IF();
	negotiation("ANYBODY","HUMANORCOMPUTER","Independents","HUMANORCOMPUTER");
	THEN();
	ENDIF();

	cout << "\nAre Venetians being played by a human? (y or n)";
	cin >> answer;
	if (answer=='n'){
		IF();
		turn(1);
		THEN();
		text("A Venetian expedition led by Emmanuel Caboro\n establishes a permanent settlement in Cuba.");
		createunit("Venetians","Engineer","No","NONE","42,48");
		ENDIF();

		IF();
		turn(1);
		THEN();
		createunit("Venetians","Carrack","No","NONE","42,46");
		ENDIF();

		IF();
		turn(3);
		THEN();
		text("Venetians land in North America.");
		createunit("Venetians","Engineer","No","NONE","26,40");
		ENDIF();

		IF();
		turn(3);
		THEN();
		createunit("Venetians","Pikemen","No","NONE","26,40");
		ENDIF();

		IF();
		turn(4);
		THEN();
		text("Venetians land in South America.");
		createunit("Venetians","Engineer","No","NONE","52,60");
		ENDIF();

		IF();
		turn(4);
		THEN();
		createunit("Venetians","Pikemen","No","NONE","52,60");
		ENDIF();
		
		IF();
		randomturn(engfreq);
		THEN();
		createunit("Venetians","Engineer","No","NONE","52,60");
		ENDIF();
		
		IF();
		randomturn(engfreq);
		THEN();
		createunit("Venetians","Engineer","No","NONE","26,40");
		ENDIF();
		
		IF();
		randomturn(galfreq);
		THEN();
		createunit("Venetians","Galleon","No","NONE","130,24");
		ENDIF();
		
		IF();
		randomturn(galfreq);
		THEN();
		createunit("Venetians","Horse Artillery","No","NONE","130,24");
		ENDIF();
		
		IF();
		randomturn(galfreq);
		THEN();
		createunit("Venetians","Halberdiers","No","NONE","130,24");
		ENDIF();
		
		IF();
		randomturn(galfreq);
		THEN();
		createunit("Venetians","Spy","Yes","NONE","130,24");
		ENDIF();
	}
	else{
		
		IF();
		randomturn(galfreq);
		THEN();
		createunit("Venetians","Spy","no","NONE","130,24");
		ENDIF();
	}

	
	cout << "\nAre Hafsids being played by a human? (y or n)";
	cin >> answer;
	if (answer=='n'){
		IF();
		turn(1);
		THEN();
		text("Hafsids wrest suzerainty of Cape Verde Islands from the Portuguese.");
		createunit("Hafsids","Engineer","No","NONE","97,59");
		ENDIF();

		IF();
		turn(1);
		THEN();
		createunit("Hafsids","Carrack","No","NONE","98,58");
		ENDIF();

		IF();
		turn(3);
		THEN();
		text("Hafsids land in South America.");
		createunit("Hafsids","Engineer","No","NONE","84,74");
		ENDIF();

		IF();
		turn(3);
		THEN();
		createunit("Hafsids","Pikemen","No","NONE","84,74");
		ENDIF();

		IF();
		turn(4);
		THEN();
		text("A second Hafsid settlement in South America is established.");
		createunit("Hafsids","Engineer","No","NONE","70,98");
		ENDIF();

		IF();
		turn(4);
		THEN();
		createunit("Hafsids","Pikemen","No","NONE","70,98");
		ENDIF();
		
		IF();
		randomturn(engfreq);
		THEN();
		createunit("Hafsids","Engineer","No","NONE","84,74");
		ENDIF();
		
		IF();
		randomturn(engfreq);
		THEN();
		createunit("Hafsids","Engineer","No","NONE","70,98");
		ENDIF();
		
		IF();
		randomturn(galfreq);
		THEN();
		createunit("Hafsids","Galleon","No","NONE","128,36");
		ENDIF();
		
		IF();
		randomturn(galfreq);
		THEN();
		createunit("Hafsids","Horse Artillery","No","NONE","128,36");
		ENDIF();
		
		IF();
		randomturn(galfreq);
		THEN();
		createunit("Hafsids","Halberdiers","No","NONE","128,36");
		ENDIF();
		
		IF();
		randomturn(galfreq);
		THEN();
		createunit("Hafsids","Spy","Yes","NONE","128,36");
		ENDIF();
	}
	else{		
		IF();
		randomturn(galfreq);
		THEN();
		createunit("Hafsids","Spy","No","NONE","128,36");
		ENDIF();
	}


	cout << "\nAre Teutonics being played by a human? (y or n)";
	cin >> answer;
	if (answer=='n'){
		IF();
		turn(1);
		THEN();
		text("Teutonics land in Newfoundland.");
		createunit("Teutonics","Engineer","No","NONE","64,22");
		ENDIF();

		IF();
		turn(1);
		THEN();
		createunit("Teutonics","Carrack","No","NONE","64,24");
		ENDIF();

		IF();
		turn(3);
		THEN();
		text("Teutonics land in North America.");
		createunit("Teutonics","Engineer","No","NONE","58,26");
		ENDIF();

		IF();
		turn(3);
		THEN();
		createunit("Teutonics","Pikemen","No","NONE","58,26");
		ENDIF();

		IF();
		turn(4);
		THEN();
		text("Another Teuton group arrives in North America.");
		createunit("Teutonics","Engineer","No","NONE","46,30");
		ENDIF();

		IF();
		turn(4);
		THEN();
		createunit("Teutonics","Pikemen","No","NONE","46,30");
		ENDIF();
		
		IF();
		randomturn(engfreq);
		THEN();
		createunit("Teutonics","Engineer","No","NONE","58,26");
		ENDIF();
		
		IF();
		randomturn(engfreq);
		THEN();
		createunit("Teutonics","Engineer","No","NONE","46,30");
		ENDIF();
		
		IF();
		randomturn(galfreq);
		THEN();
		createunit("Teutonics","Galleon","No","NONE","142,14");
		ENDIF();
		
		IF();
		randomturn(galfreq);
		THEN();
		createunit("Teutonics","Horse Artillery","No","NONE","142,14");
		ENDIF();
		
		IF();
		randomturn(galfreq);
		THEN();
		createunit("Teutonics","Halberdiers","No","NONE","142,14");
		ENDIF();
		
		IF();
		randomturn(galfreq);
		THEN();
		createunit("Teutonics","Spy","Yes","NONE","142,14");
		ENDIF();
	}
	else{
		IF();
		randomturn(galfreq);
		THEN();
		createunit("Teutonics","Spy","No","NONE","142,14");
		ENDIF();
	}

	IF();
	unitkilled("Lancers","ANYBODY","ANYBODY");
	THEN();
	createunit("Barbarians","Hussars","No","NONE","21,31");
	ENDIF();

	IF();
	unitkilled("Lancers","ANYBODY","ANYBODY");
	THEN();
	createunit("Barbarians","Hussars","No","NONE","16,24");
	ENDIF();

	IF();
	unitkilled("Culverin","ANYBODY","ANYBODY");
	THEN();
	createunit("Barbarians","Pikemen","No","NONE","42,22");
	ENDIF();

	IF();
	unitkilled("Halberdiers","ANYBODY","ANYBODY");
	THEN();
	createunit("Barbarians","Bowmen","No","NONE","37,31");
	ENDIF();

	IF();
	unitkilled("Culverin","ANYBODY","ANYBODY");
	THEN();
	createunit("Barbarians","Pikemen","No","NONE","53,69");
	ENDIF();

	IF();
	unitkilled("Halberdiers","ANYBODY","ANYBODY");
	THEN();
	createunit("Barbarians","Bowmen","No","NONE","64,78");
	ENDIF();

	IF();
	unitkilled("Culverin","ANYBODY","ANYBODY");
	THEN();
	createunit("Barbarians","Pikemen","No","NONE","64,78");
	ENDIF();

	IF();
	unitkilled("Halberdiers","ANYBODY","ANYBODY");
	THEN();
	createunit("Barbarians","Bowmen","No","NONE","57,103");
	ENDIF();

	char loc[7][255]={
		"129,71",
			"134,78",
			"143,95",
			"154,84",
			"148,68",
			"139,69",
			"146,54"};

	for (x=0; x<7 ; x++){
		IF();
		unitkilled("Lancers","ANYBODY","ANYBODY");
		THEN();
		createunit("Barbarians","Pikemen","No","NONE",loc[x]);
		ENDIF();

		IF();
		unitkilled("Culverin","ANYBODY","ANYBODY");
		THEN();
		createunit("Barbarians","Bowmen","No","NONE",loc[x]);
		ENDIF();
	}

	IF();
	randomturn(galfreq);
	THEN();
	createunit("Barbarians","Pikemen","No","NONE","148,68");
	ENDIF();

	IF();
	randomturn(galfreq);
	THEN();
	createunit("Barbarians","Bowmen","No","NONE","139,69");
	ENDIF();

	IF();
	randomturn(galfreq);
	THEN();
	createunit("Barbarians","Pikemen","No","NONE","37,31");
	ENDIF();

	IF();
	randomturn(galfreq);
	THEN();
	createunit("Barbarians","Bowmen","No","NONE","43,21");
	ENDIF();

	IF();
	randomturn(galfreq);
	THEN();
	createunit("Barbarians","Pikemen","No","NONE","53,69");
	ENDIF();

	IF();
	randomturn(galfreq);
	THEN();
	createunit("Barbarians","Bowmen","No","NONE","64,78");
	ENDIF();

	endevents();
	fout.close();
}

void createunit(char owner[255],
				char unit[255],
				char veteran[255],
				char homecity[255],
				char loc[255]){
	fout << "CreateUnit\n";
	fout << "owner=" << owner << "\n";
	fout << "unit=" << unit << "\n";
	fout << "veteran=" << veteran << "\n";
	fout << "homecity=" << homecity << "\n";
	fout << "locations\n" << loc << "\nendlocations\n";
}

void unitkilled(char unit[255],
				char attacker[255],
				char defender[255]){
	fout << "UnitKilled\n";
	fout << "unit=" << unit << "\n";
	fout << "attacker=" << attacker << "\n";
	fout << "defender=" << defender << "\n";
}

void randomturn(int denominator){
	fout << "RandomTurn\n";
	fout << "denominator=" << denominator << "\n";
}

void turn(int turn){
	fout << "Turn\n";
	fout << "turn=" << turn << "\n";
}

void negotiation(char talker[255],
				 char talkertype[255],
				 char listener[255],
				 char listenertype[255]){
    fout << "Negotiation\n";
    fout << "talker=" << talker << "\n";
    fout << "talkertype="<< talkertype << "\n";
    fout << "listener="<< listener << "\n";
    fout << "listenertype="<< listenertype << "\n";
}

void text(char text[32000]){
	fout << "Text\n";
	fout << text << "\n";
	fout << "EndText\n";
}


void beginevents(){
	fout << "@BEGINEVENTS\n";
}

void endevents(){
	fout << "@ENDEVENTS\n";
}

void IF(){
	fout << "@IF\n";
}

void THEN(){
	fout << "@THEN\n";
}

void ENDIF(){
	fout << "@ENDIF\n";
}

void justonce(){
	fout << "JustOnce\n";
}

void noschism(char defender[255]){
	fout << "NoSchism\n";
	fout << "defender=" << defender << "\n";
}

void citytaken(char city[255],
			   char attacker[255],
			   char defender[255]){
	fout << "CityTaken\n";
	fout << "city=" << city << "\n";
	fout << "attacker=" << attacker << "\n";
	fout << "defender=" << defender << "\n";
}

void playwavefile(char filename[255]){
	fout << "PlayWaveFile\n";
	fout << filename << "\n";
}

void scenarioloaded(){
	fout << "ScenarioLoaded\n";
}

void debug(){
	fout << "@DEBUG\n";
}